/* WCEDialogPeer.java
   Copyright (C) 2005 Free Software Foundation, Inc.

This file is part of GNU Classpath.

GNU Classpath is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; version 2 of the License.

GNU Classpath is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU Classpath; see the file COPYING.  If not, write to the
Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA.

Linking this library statically or dynamically with other modules is
making a combined work based on this library.  Thus, the terms and
conditions of the GNU General Public License cover the whole
combination.

As a special exception, the copyright holders of this library give you
permission to link this library with independent modules to produce an
executable, regardless of the license terms of these independent
modules, and to copy and distribute the resulting executable under
terms of your choice, provided that you also meet, for each linked
independent module, the terms and conditions of the license of that
module.  An independent module is a module which is not derived from
or based on this library.  If you modify this library, you may extend
this exception to your version of the library, but you are not
obligated to do so.  If you do not wish to do so, delete this
exception statement from your version. */

package gnu.java.awt.peer.wce;

import java.awt.Dialog;
import java.awt.GraphicsEnvironment;
import java.awt.Rectangle;
import java.awt.peer.DialogPeer;


public class WCEDialogPeer extends WCEWindowPeer implements DialogPeer {
	public WCEDialogPeer(Dialog dialog) {
		super(dialog);
		setTitle(dialog.getTitle());
		setResizable(dialog.isResizable());
	}
	
	protected int createNative(int hParentWnd, int x, int y, int width, int height) {
		return createNativeDialog(hParentWnd, x, y, width, height, ((Dialog) getComponent()).isUndecorated());
	}
	
	native int createNativeDialog(int hParentWnd, int x, int y, int width, int height, boolean undecorated);

	public void setResizable(boolean resizable) {
		if ((WCEToolkit.getFloatingFlags() & WCEToolkit.DIALOG_IS_FLOATING) != 0) {
			setNativeResizable(getWindowHandle(), resizable);
		}
	}
	
	/**
	 * ユーザの操作によるウインドウサイズ変更を有効／無効にする
	 */
	native void setNativeResizable(int windowHandle, boolean resizable);
	
	public void setBounds(int x, int y, int width, int height) {
		if ((WCEToolkit.getFloatingFlags() & WCEToolkit.DIALOG_IS_FLOATING) != 0) {
			GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
			Rectangle rect = ge.getMaximumWindowBounds();
			if (y < rect.y) {
				y = rect.y;
			}
			super.setBounds(x, y, width, height);
		}
	}
	
	public void setTitle (String title) {
		setNativeText(getWindowHandle(), title);
	}
	
	public void setVisible(boolean visible) {
		Dialog dialog = (Dialog) getComponent();
		setNativeVisible(getWindowHandle(), visible, dialog.isModal());
	}
	
	/**
	 * ダイアログボックスの表示／非表示を切り替える
	 */
	private native void setNativeVisible(int windowHandle, boolean visible, boolean modal);

}
